Attribute VB_Name = "Fct_base"
Global Const EPSILON = 0.000001

'---------------------------------------------------------------------------
' Point en 3D
'---------------------------------------------------------------------------
Public Type Point3
    X As Double
    Y As Double
    Z As Double
End Type

'---------------------------------------------------------------------------
' Line en 3D
'---------------------------------------------------------------------------
Public Type Line3
    origin As Point3
    Direction As Point3
End Type


    
'Produit vectoriel
Function VecProd(P1 As Point3, P2 As Point3) As Point3
Dim P4 As Point3

 P4.X = (P1.Y * P2.Z) - (P1.Z * P2.Y)
 P4.Y = (P1.Z * P2.X) - (P1.X * P2.Z)
 P4.Z = (P1.X * P2.Y) - (P1.Y * P2.X)
 VecProd = P4
 
End Function

'Produit Scalaire
Function Dot(p As Point3, Q As Point3) As Double
    Dot = p.X * Q.X + p.Y * Q.Y + p.Z * Q.Z
End Function

'Ajout de vecteur
Function VecAdd(P1 As Point3, P2 As Point3, Optional F As Double = 1) As Point3
 Dim P3 As Point3
 P3.X = P1.X + F * P2.X
 P3.Y = P1.Y + F * P2.Y
 P3.Z = P1.Z + F * P2.Z
 VecAdd = P3
End Function

' Soustraction de vecteur
Function VecSub(P1 As Point3, P2 As Point3, Optional t As Double = 1) As Point3
 VecSub.X = P1.X - t * P2.X
 VecSub.Y = P1.Y - t * P2.Y
 VecSub.Z = P1.Z - t * P2.Z
End Function

Function Longueur(ByRef P1 As Point3) As Double
  Longueur = Sqr((P1.X ^ 2) + (P1.Y ^ 2) + (P1.Z ^ 2))
End Function
' transforme un vecteur en vecteur unitaire
Function VecteurUnitaire(ByRef P1 As Point3) As Point3
Dim Norm As Double
Norm = Sqr((P1.X) ^ 2 + (P1.Y) ^ 2 + (P1.Z) ^ 2)
If Norm = 0 Then
    Exit Function
End If
    
    VecteurUnitaire.X = P1.X / Norm
    VecteurUnitaire.Y = P1.Y / Norm
    VecteurUnitaire.Z = P1.Z / Norm
End Function



